package com.zx.dataservice.service.impl;

import com.jfinal.plugin.activerecord.Db;
import com.jfinal.plugin.activerecord.Record;
import com.zx.dataservice.options.DataOptions;
import com.zx.dataservice.options.WSOptions;
import com.zx.dataservice.pojo.StockRestPojo;
import com.zx.dataservice.service.ChoiceHisService;
import com.zx.dataservice.utils.BigdecimalUtil;
import com.zx.dataservice.utils.DateUtils;
import com.zx.dataservice.utils.WorkingDayUtil;
import com.zx.dataservice.vo.StockRestRedisVO;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Service
public class ChoiceHisServiceImpl implements ChoiceHisService {


    @Override
    public void analysisHistData() {
        List<Record> records = Db.use("gp").find("select id, code, name from t_stock_base_info where is_rest_add = 0 order by id asc ");
        for (Record record : records) {
            String str = Db.use("gp").queryStr("select  dates  from  " +
                    " data_hist_" + record.getStr("code").replace(".", "_").toLowerCase() +
                    " order by realtime+0 desc  limit 1 ");
            if (StringUtils.isNotBlank(str)) {
                String newTime = new WorkingDayUtil().getNewTime(str, "yyyy/MM/dd", 5);
                if (DateUtils.dateTime("yyyy/MM/dd", newTime).before(new Date())) {  // 五天内还是 无数据
                    System.out.println("五天内无数据股票****" + record.getStr("code") + "***" + newTime);
                    Db.use("gp").update(" update t_stock_base_info set is_rest_add = 2  where id = ? ", record.get("id") + "");
                }
            }
        }

        List<Record> record2s = Db.use("zq").find("select id, code, name from t_stock_base_info where is_rest_add = 0 order by id asc ");
        for (Record record : record2s) {
            String str = Db.use("zq").queryStr("select  dates  from  " +
                    " data_hist_" + record.getStr("code").replace(".", "_").toLowerCase() +
                    " order by realtime+0 desc  limit 1 ");
            if (StringUtils.isNotBlank(str)) {
                String newTime = new WorkingDayUtil().getNewTime(str, "yyyy/MM/dd", 5);
                if (DateUtils.dateTime("yyyy/MM/dd", newTime).before(new Date())) {  // 五天内还是 无数据
                    System.out.println("五天内无数据股票****" + record.getStr("code") + "***" + newTime);
                    Db.use("zq").update(" update t_stock_base_info set is_rest_add = 2  where id = ? ", record.get("id") + "");
                }
            }
        }

    }

    @Override
    public void toAnalysisHistData() {
        //一共3种情况 ，1.历史数据不需要风控 2.历史数据需要风控且没有风控记录且没有实时数据  3.历史数据存在风控并且存在实时数据
        //1.循环需要风控的记录
        for (String key : DataOptions.keySet()) {
            try {
                if("keyall".equals(key)){
                    continue;
                }
                //2. 查询备份表 最后一条记录 ，在 正常表里查询是否 为最后一条
                String keyArr[] = key.split("_"); // hy_BTC_LTC
                String code = keyArr[1];
                String tocode = keyArr[2];
                String oldTabeName = "data_hist_" + code.replace(".", "_").toLowerCase();
                String toTabeName = "data_hist_" + tocode.replace(".", "_").toLowerCase() + "_" + keyArr[0].replace(".", "_").toLowerCase();
                String tortTabeName = "data_rt_" + tocode.replace(".", "_").toLowerCase() + "_" + keyArr[0].replace(".", "_").toLowerCase();
                Record todRec = Db.use("gp").findFirst(" select id,dates from  " + toTabeName + "  order by dates desc  limit 1 ");
                String riskTableName = "risk_control_formula_history_" + keyArr[0];
                List<Record> recordsnew = new ArrayList<>();
                if (todRec != null) { // 不为Null 那么查询 正常表内 此时间后的所有 记录
                    List<Record> oldRecordList = Db.use("gp").find(" select * from  " + oldTabeName + " where dates > '" + todRec.get("dates") + "' order by dates asc ");
                    for (Record record : oldRecordList) {
                        Record record1 = new Record();
                        record1.setColumns(record);
                        // 查询当天的数据 开盘价
                        Record ropen = Db.use("gp").findFirst("select id,now from " + tortTabeName + "  where  " +
                                "date = '" + record.getStr("dates").replace("-", "").replace("/", "") + "' " +
                                " and  high <> '0' and low <> '0' and open <> '0'  order by time+0 asc LIMIT 1    ");
                        if(ropen!=null){  // 存在当天的数据就直接取 当天的数据
                            //开盘价
                            String openn = ropen.get("now")+"";
                            // 昨收
                            String preclosen = ropen.get("preclose")+"";
                            //收盘价
                            Record rclose = Db.use("gp").findFirst("select id,now from " + tortTabeName + "  where  " +
                                    "date = '" + record.getStr("dates").replace("-", "").replace("/", "") + "' " +
                                    " and  high <> '0' and low <> '0' and open <> '0'  order by time+0 desc LIMIT 1    ");
                            String closen = ropen.get("now")+"";
                            //最高，最低
                            Record rmaxmin = Db.use("gp").findFirst("select min(now) min ,max(now) max from " + tortTabeName + "  where  " +
                                    "date = '" + record.getStr("dates").replace("-", "").replace("/", "") + "'  ");
                            String minn = ropen.get("min")+"";
                            String maxn = ropen.get("max")+"";
                            BigDecimal bbb = new BigDecimal(minn).add(new BigDecimal(maxn));
                            // 平均
                            String AVERAGE =  bbb.divide(new BigDecimal(2), 4, 2)+"";
                            // change 涨跌
                            String changen = BigdecimalUtil.getNew(rclose+ "", preclosen, "-", 4, 2);
                            // 涨跌幅 pctchange
                            String pctchangen = BigdecimalUtil.getNew(changen, preclosen, "/", 4, 2);
                            record1.set("open",openn);
                            record1.set("preclose",preclosen);
                            record1.set("close",closen);
                            record1.set("low",minn);
                            record1.set("high",maxn);
                            record1.set("average",AVERAGE);
                            record1.set("change",changen);
                            record1.set("pctchange",pctchangen);
                            recordsnew.add(record1);
                        }else {  // 没有今天的实时数据
                            // 判断此天是否 存在风控  开盘价
                            // 当天存在风控
                            Record recordtoday = Db.use("gp").findFirst(" select id ,code,minimumFluctuation as mini,riskControl as risk,multiples," +
                                    "tocode,startTime,endTime" +
                                    " from " + riskTableName + "  where   code = '" + code + "' and tocode = '" + tocode + "' " +
                                    " and (endTime is null or " +
                                    " ( startTime >  " + DateUtils.timeInMillis(DateUtils.stampToDate(record.get("realTime") + "000", "yyyy-MM-dd") + " 00:00:00") + " " +
                                    " AND endTime < " + DateUtils.timeInMillis(DateUtils.stampToDate(record.get("realTime") + "000", "yyyy-MM-dd") + " 59:59:59") + " )" +
                                    " ) limit 1 ");
                            if(recordtoday!=null){
                                String mini = recordtoday.get("mini");// 最小波动
                                String multiples = recordtoday.get("multiples");// 倍数
                                String risk1 = recordtoday.getStr("risk").substring(0, 1); // 风险  +-*/110
                                String risk2 = BigdecimalUtil.getNew(mini,
                                        recordtoday.getStr("risk").substring(1, recordtoday.getStr("risk").length()), "*", 4, 2);

                                // 如果 在 id 天 0点之前开了 风控 ，  startTime < DateUtils.timeInMillis(DateUtils.stampToDate(id + "000", "yyyy-MM-dd")+" 00:00:00")
                                //     (endTime is null  or  endTime > DateUtils.timeInMillis(DateUtils.stampToDate(id + "000", "yyyy-MM-dd")+" 00:00:00"))  // open
                                String nhigh = BigdecimalUtil.getNew(record.get("high") + "", risk2, risk1, 4, 2, multiples);
                                String nlow = BigdecimalUtil.getNew(record.get("low") + "", risk2, risk1, 4, 2, multiples);
                                String openn = BigdecimalUtil.getNew(record.get("open") + "", risk2, risk1, 4, 2,multiples) ;
                                String closen = BigdecimalUtil.getNew(record.get("close") + "", risk2, risk1, 4, 2,multiples) ;
                                String preclose = BigdecimalUtil.getNew(record.get("preclose")+ "", risk2, risk1, 4, 2, multiples);
                                BigDecimal bbb = new BigDecimal(nhigh).add(new BigDecimal(nlow));
                                String AVERAGE =  bbb.divide(new BigDecimal(2), 4, 2)+"";
                                String CHANGE  =  BigdecimalUtil.getNew(closen, preclose, "-", 4, 2);
                                String pctchange =  BigdecimalUtil.getNew(CHANGE, preclose, "/", 4, 2);
                                record1.set("open",openn);
                                record1.set("preclose",preclose);
                                record1.set("close",closen);
                                record1.set("low",nlow);
                                record1.set("high",nhigh);
                                record1.set("average",AVERAGE);
                                record1.set("change",CHANGE);
                                record1.set("pctchange",pctchange);
                                recordsnew.add(record1);
                            }else {
                                recordsnew.add(record1);
                            }
                        }
                    }

                } else {
                    String v = DataOptions.get(key);
                    String valueArr [] = v.split("&");
                    String mini = valueArr[1];// 最小波动
                    String risk1 = valueArr[2].substring(0, 1); // 风险  +-*/110
                    String multiples = valueArr[3]; //倍数
                    String risk2 = BigdecimalUtil.getNew(mini,valueArr[2].substring(1, valueArr[2].length()),"*",4,2) ; // 风险  +-*/110

                    List<Record> oldRecordList = Db.use("gp").find(" select * from  " + oldTabeName + "   order by dates asc ");
                    for (Record record : oldRecordList) {
                        Record record1 = new Record();
                        record1.setColumns(record);
                        // 如果是倍数风控
                        if(!"1".equals(multiples)){
                            //是倍数风控 则表示初始数据需要倍数化
                            String nhigh = BigdecimalUtil.getNew(record.get("high") + "", risk2, risk1, 4, 2, multiples);
                            String nlow = BigdecimalUtil.getNew(record.get("low") + "", risk2, risk1, 4, 2, multiples);
                            String openn = BigdecimalUtil.getNew(record.get("open") + "", risk2, risk1, 4, 2,multiples) ;
                            String closen = BigdecimalUtil.getNew(record.get("close") + "", risk2, risk1, 4, 2,multiples) ;
                            String preclose = BigdecimalUtil.getNew(record.get("preclose")+ "", risk2, risk1, 4, 2, multiples);
                            BigDecimal bbb = new BigDecimal(nhigh).add(new BigDecimal(nlow));
                            String AVERAGE =  bbb.divide(new BigDecimal(2), 4, 2)+"";
                            String CHANGE  =  BigdecimalUtil.getNew(closen, preclose, "-", 4, 2);
                            String pctchange =  BigdecimalUtil.getNew(CHANGE, preclose, "/", 4, 2);
                            record1.set("open",openn);
                            record1.set("preclose",preclose);
                            record1.set("close",closen);
                            record1.set("low",nlow);
                            record1.set("high",nhigh);
                            record1.set("average",AVERAGE);
                            record1.set("change",CHANGE);
                            record1.set("pctchange",pctchange);
                            recordsnew.add(record1);
                        }else {
                            recordsnew.add(record1);
                        }
                    }
                }
                if (recordsnew.size() > 0) {
                    int size = recordsnew.size();
                    if (500 >= size) {
                        Db.use("gp").batchSave(toTabeName, recordsnew, recordsnew.size());
                    } else {
                        int serial = size / 500;
                        for (int ii = 0; ii < serial; ii++) {
                            Db.use("gp").batchSave(toTabeName, recordsnew.subList(ii * 500, ii * 500 + 500), 500);
                        }
                        int remain = size - serial * 500;
                        Db.use("gp").batchSave(toTabeName, recordsnew.subList(serial * 500, size), remain);
                    }
                }

            } catch (Exception e) {

            }
        }
    }
}
