package com.zx.dataservice.task;

import com.zx.dataservice.service.ChoiceBondService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

/**
 * 解析东方财富实时数据
 */
@Component
public class AnalysisBondRestDataTask {

    private static final Logger log = LoggerFactory.getLogger(AnalysisBondRestDataTask.class);

    @Autowired
    private ChoiceBondService choiceBondService;

    @Async("executorBond")
    @Scheduled(fixedRate=10)
    public void toAnalysisRestData() {
        doTask("now");
    }

    public void doTask(String type) {
        this.choiceBondService.analysisBondRestData(type);
    }

    @Async("executorAfterBond")
    @Scheduled(cron = "0/2 * 15,16,17,18 * * ? ")
    public void toAnalysisRestAfterData() {
        this.choiceBondService.analysisBondRestDataAfter("after");
    }

}
