package com.zx.dataservice.task;

import com.zx.dataservice.service.ChoiceHisService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

/**
 * 凌晨去掉退盘数据
 * 更新指数的 风控数据
 */
@Component
public class AnalysisHisDataTask {

    private static final Logger log = LoggerFactory.getLogger(AnalysisHisDataTask.class);

    @Autowired
    private ChoiceHisService choiceHisService;


    @Scheduled(cron = "1 1 1 * * ? ")
    public void toAnalysisRestAfterData() {
        this.choiceHisService.analysisHistData();
    }

    /**
     * 凌晨6点处理指数风控历史数据
     */
    @Scheduled(cron = "0 30 6 * * ? ")
    public void toAnalysisHistData() {
        this.choiceHisService.toAnalysisHistData();
    }

}
