package com.zx.dataservice.task;

import com.zx.dataservice.service.ChoiceTempIndexService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

/**
 * 解析东方财富实时数据
 */
@Component
public class AnalysisTempIndexRestDataTask {

    private static final Logger log = LoggerFactory.getLogger(AnalysisTempIndexRestDataTask.class);

    @Autowired
    private ChoiceTempIndexService choiceTempIndexService;

    @Async("executorTempIndex")
    @Scheduled(fixedRate=10)
    public void toAnalysisRestData() {
        doTask("now");
    }

    public void doTask(String type) {
        this.choiceTempIndexService.analysisStockRestData(type);
    }

    @Async("executorTempAfterIndex")
    @Scheduled(cron = "0/2 * 15,16,17,18 * * ? ")
    public void toAnalysisRestAfterData() {
        this.choiceTempIndexService.analysisStockRestDataAfter("after");
    }



}
