package com.zx.dataservice.utils;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

/**
 * 获取排除节假日和星期六，星期天的时间
 * Created by qlm on 2020-12-07
 */
public class WorkingDayUtil {
    private static List<Calendar> holidayList = new ArrayList<Calendar>();  //节假日列表
    private static boolean holidayFlag;

    private static Logger LOG = LoggerFactory.getLogger(WorkingDayUtil.class);


    /**
     * <p>Title: main </P>
     * <p>Description: TODO </P>
     * @param args
     * return void    测试方法
     * throws
     * date
     */
    public static void main(String[] args) {
        try {

            DateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            Calendar ca = Calendar.getInstance();
            Date d = df.parse("2021-04-02 00:00:00");
            ca.setTime(d);//设置当前时间

            WorkingDayUtil wd = new WorkingDayUtil();//初始节假日
            wd.initHolidayList("2021-01-01");
            wd.initHolidayList("2021-01-02");
            wd.initHolidayList("2021-01-03");
            wd.initHolidayList("2021-02-11");
            wd.initHolidayList("2021-02-12");
            wd.initHolidayList("2021-02-13");
            wd.initHolidayList("2021-02-14");
            wd.initHolidayList("2021-02-15");
            wd.initHolidayList("2021-02-16");
            wd.initHolidayList("2021-02-17");
            wd.initHolidayList("2021-04-03");
            wd.initHolidayList("2021-04-04");
            wd.initHolidayList("2021-04-05");
            wd.initHolidayList("2021-05-01");
            wd.initHolidayList("2021-05-02");
            wd.initHolidayList("2021-05-03");
            wd.initHolidayList("2021-05-04");
            wd.initHolidayList("2021-05-05");
            wd.initHolidayList("2021-06-12");
            wd.initHolidayList("2021-06-13");
            wd.initHolidayList("2021-06-14");
            wd.initHolidayList("2021-09-19");
            wd.initHolidayList("2021-09-20");
            wd.initHolidayList("2021-09-21");
            wd.initHolidayList("2021-10-01");
            wd.initHolidayList("2021-10-02");
            wd.initHolidayList("2021-10-03");
            wd.initHolidayList("2021-10-04");
            wd.initHolidayList("2021-10-05");
            wd.initHolidayList("2021-10-06");
            wd.initHolidayList("2021-10-07");

            Calendar c = wd.addDateByWorkDay(ca,5);
            System.out.println(df.format(c.getTime()));

        } catch ( Exception e) {
            // TODO: handle exception
            System.out.println(e.getClass());
            if(e.toString().length()>500){                LOG.error(e.toString().substring(0,450));            }else {                LOG.error(e.toString());            }
        }

    }

    
    //根据当前时间和天数获取 截至时间
    public String getNewTime(String newTime,String format ,int workDay){
        DateFormat df = new SimpleDateFormat(format);
        Calendar ca = Calendar.getInstance();
        Date d = null;
        try {
            d = df.parse(newTime);
        } catch (ParseException e) {
            if(e.toString().length()>500){                LOG.error(e.toString().substring(0,450));            }else {                LOG.error(e.toString());            }
        }
        ca.setTime(d);//设置当前时间

        WorkingDayUtil wd = new WorkingDayUtil();
        wd.initHolidayList("2021-01-01");
        wd.initHolidayList("2021-01-02");
        wd.initHolidayList("2021-01-03");
        wd.initHolidayList("2021-02-11");
        wd.initHolidayList("2021-02-12");
        wd.initHolidayList("2021-02-13");
        wd.initHolidayList("2021-02-14");
        wd.initHolidayList("2021-02-15");
        wd.initHolidayList("2021-02-16");
        wd.initHolidayList("2021-02-17");
        wd.initHolidayList("2021-04-03");
        wd.initHolidayList("2021-04-04");
        wd.initHolidayList("2021-04-05");
        wd.initHolidayList("2021-05-01");
        wd.initHolidayList("2021-05-02");
        wd.initHolidayList("2021-05-03");
        wd.initHolidayList("2021-05-04");
        wd.initHolidayList("2021-05-05");
        wd.initHolidayList("2021-06-12");
        wd.initHolidayList("2021-06-13");
        wd.initHolidayList("2021-06-14");
        wd.initHolidayList("2021-09-19");
        wd.initHolidayList("2021-09-20");
        wd.initHolidayList("2021-09-21");
        wd.initHolidayList("2021-10-01");
        wd.initHolidayList("2021-10-02");
        wd.initHolidayList("2021-10-03");
        wd.initHolidayList("2021-10-04");
        wd.initHolidayList("2021-10-05");
        wd.initHolidayList("2021-10-06");
        wd.initHolidayList("2021-10-07");

        Calendar c = wd.addDateByWorkDay(ca,workDay);

        return  df.format(c.getTime());

    }

    /**
     *
     * <p>Title: addDateByWorkDay </P>
     * <p>Description: TODO  计算相加day天，并且排除节假日和周末后的日期</P>
     * @param calendar  当前的日期
     * @param day  相加天数
     * @return
     * return Calendar    返回类型   返回相加day天，并且排除节假日和周末后的日期
     * throws
     * date 2020-12-07 上午10:32:55
     */
    public Calendar addDateByWorkDay(Calendar calendar,int day){

        try {
            for (int i = 0; i < day; i++) {

                calendar.add(Calendar.DAY_OF_MONTH, 1);

                if(checkHoliday(calendar)){
                    i--;
                }
            }
            return calendar;

        } catch (Exception e) {
            if(e.toString().length()>500){                LOG.error(e.toString().substring(0,450));            }else {                LOG.error(e.toString());            }
        }
        return calendar;
    }
    /**
     *
     * <p>Title: checkHoliday </P>
     * <p>Description: TODO 验证日期是否是节假日</P>
     * @param calendar  传入需要验证的日期
     * @return
     * return boolean    返回类型  返回true是节假日，返回false不是节假日
     * throws
     * date 2020-12-07 上午10:13:07
     */
    public boolean checkHoliday(Calendar calendar) throws Exception{

        //判断日期是否是周六周日
        if(calendar.get(Calendar.DAY_OF_WEEK) == Calendar.SUNDAY ||
                calendar.get(Calendar.DAY_OF_WEEK) == Calendar.SATURDAY){
            return true;
        }
        //判断日期是否是节假日
        for (Calendar ca : holidayList) {
            if(ca.get(Calendar.MONTH) == calendar.get(Calendar.MONTH) &&
                    ca.get(Calendar.DAY_OF_MONTH) == calendar.get(Calendar.DAY_OF_MONTH)&&
                    ca.get(Calendar.YEAR) == calendar.get(Calendar.YEAR)){
                return true;
            }
        }

        return false;
    }

    /**
     *
     * <p>Title: initHolidayList </P>
     * <p>Description: TODO  把所有节假日放入list</P>
     * @param date 格式2020-12-07
     * return void    返回类型
     * throws
     * date 2020-12-07 上午10:11:35
     */
    public void initHolidayList( String date){

        String [] da = date.split("-");

        Calendar calendar = Calendar.getInstance();
        calendar.set(Calendar.YEAR, Integer.valueOf(da[0]));
        calendar.set(Calendar.MONTH, Integer.valueOf(da[1])-1);//月份比正常小1,0代表一月
        calendar.set(Calendar.DAY_OF_MONTH, Integer.valueOf(da[2]));
        holidayList.add(calendar);
    }

}

